DAT programName  byte "AdjustCenters130328a", 0  ' I like to have the name of the program
                                   ' displayed in a terminal window.

CON

  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000

  DEFAULT_MAX_PULSE = 2000
  DEFAULT_MIN_PULSE = 1000
  ABSOLUTE_MAX_PULSE = 3000
  ABSOLUTE_MIN_PULSE = 300
  MIN_RADIUS = Header#F_BOT_WIDTH_MIDDLE
  MAX_RADIUS = 1_000_000
  STOP = 1500
  CENTER = STOP
  LEGS_IN_USE = 6
  SERVOS_PER_LEG = 3   
  SERVOS_IN_USE = LEGS_IN_USE * SERVOS_PER_LEG
  DEFAULT_FRAMES_PER_PERIOD = 48 '100 '300
  MAX_PERIOD = 1000
  MIN_PERIOD = 50
  FULL_CIRCLE = 360
  PSEUDO_FULL_CIRCLE = FULL_CIRCLE * PSEUDO_MULTIPLIER'36000
  'GRAVITY = 981               ' times 100
  DEFAULT_REFRESH_HZ = 50

  #0, WAIST_SERVO, HIP_SERVO, KNEE_SERVO
  WAIST_ = Header#WAIST
  HIP_ = Header#HIP
  KNEE_ = Header#KNEE
  
  DEBUG_BAUD = 115200

  SERVOS_PER_DISPLAY_LINE = 6

  CHANGE_ARRAYS = 4
  THREE_DIMENSIONS = 3
  
  STACK_SIZE = 100

  
  
  F_DEFAULT_TURN = Header#F_BOT_WIDTH_MIDDLE '100.0
  DEFAULT_RADIUS = round(F_DEFAULT_TURN)'100


  ' lift is distance from all servos centered
  ' in positive direction
  F_DEFAULT_STRIDE_LENGTH = Header#F_DEFAULT_STRIDE_LENGTH
  F_DEFAULT_LIFT_X = Header#F_DEFAULT_LIFT_X 
  F_DEFAULT_LIFT_Y = Header#F_DEFAULT_LIFT_Y 
  F_DEFAULT_LIFT_Z = Header#F_DEFAULT_LIFT_Z 
  'DEFAULT_LIFT_Z = 51 '0 '-DEFAULT_Z
  'DEFAULT_LIFT_Y = 20 'DEFAULT_Y + 20
  PSEUDO_MULTIPLIER = 1000
  F_PI_OVER_THREE = pi / 3.0              
  F_NEG_PI_OVER_THREE = pi / 3.0              
  F_PI_OVER_TWO = pi / 2.0
  F_TWO_PI = pi * 2.0
  F_ZERO = 0.0
  F_ONE = 1.0
  F_2 = 2.0
  F_40 = 40.0
  F_1000 = 1000.0

  DEFAULT_HEADING = 90
  DIFFERENCE_THRESHOLD = 120
  
  'leg names/numbers
  #0, FORWARD_PORT, MIDDLE_PORT, REAR_PORT, FORWARD_STARBOARD, MIDDLE_STARBOARD, {
  } REAR_STARBOARD

  OLD_IK_TEST_LEG = FORWARD_STARBOARD
  NEW_IK_TEST_LEG = REAR_STARBOARD
  
  ' IK parameters
  ' When changing multiple parameters use following proiority:
  ' period, direction, radius
  #0, NO_CHANGE_IK, RADIUS_IK, DIRECTION_IK, PERIOD_IK, STRIDE_IK, LIFT_IK, LEAN_IK

  #0, NORMAL_MODE, FIGURE8_MODE
  
  STRAIGHT = POSX

  QUOTE = 34
  CR = 13
  
VAR

  long frameInterval, lastRefresh, pTime, time
  
  'long maxPosition[SERVOS_IN_USE], minPosition[SERVOS_IN_USE]
  long period', servoSide[LEGS_IN_USE], extendEndpoints  

  long fPeriod
  long refreshHz, fRefreshHz
  'long fCenter[SERVOS_IN_USE], fHalfRange[SERVOS_IN_USE]
  'long defaultOffset[SERVOS_IN_USE], defaultPosition[SERVOS_IN_USE]
  'long motionFromCenter
  long targetX[LEGS_IN_USE], targetY[LEGS_IN_USE], targetZ[LEGS_IN_USE]
  'long r1t
  long fInitX[LEGS_IN_USE], fInitY[LEGS_IN_USE], fInitZ[LEGS_IN_USE]
  long fMidStepX[LEGS_IN_USE], fMidStepY[LEGS_IN_USE], fMidStepZ[LEGS_IN_USE]
  'long fTargetYFrame1[LEGS_IN_USE]
  'long fR1tSquared[LEGS_IN_USE], f2L1,
  long fHalfPeriod, fQuarterPeriod

  'long fLiftX[LEGS_IN_USE], fLiftY[LEGS_IN_USE], fLiftZ[LEGS_IN_USE]
  long fPulsesPerRadian

  
  long servoPosition[SERVOS_IN_USE], previousPosition[SERVOS_IN_USE]
  
  long stack[STACK_SIZE]
  long fRadiansPerFrame

  long fTheta0New[LEGS_IN_USE], fX3F1New[LEGS_IN_USE], fX1F0New[LEGS_IN_USE]
  long fR13SquaredNew[LEGS_IN_USE], fPhi2New[LEGS_IN_USE], fTheta2New[LEGS_IN_USE]
  long fPhi2[LEGS_IN_USE], fRhoNew[LEGS_IN_USE], fPhi1New[LEGS_IN_USE]
  long fTheta1New[LEGS_IN_USE]
  long fR13[LEGS_IN_USE], fFinalX[LEGS_IN_USE], fFinalY[LEGS_IN_USE], fFinalZ[LEGS_IN_USE]
  long directionNew[SERVOS_IN_USE], fAdjustedAngle[LEGS_IN_USE]
  long centerPtr, centerPosition[SERVOS_IN_USE]
  long fForwardStride[LEGS_IN_USE], fBackwardStride[LEGS_IN_USE]
  
  'long fMidStepX[LEGS_IN_USE], fMidStepY[LEGS_IN_USE], fMidStepZ[LEGS_IN_USE]

  ' ******* Keep Below Together *******
  long frameCount[LEGS_IN_USE]
  long fTargetX[LEGS_IN_USE], fTargetY[LEGS_IN_USE], fTargetZ[LEGS_IN_USE]
  long fDxGround[LEGS_IN_USE], fDyGround[LEGS_IN_USE], fDzGround[LEGS_IN_USE]
  long fDxUp[LEGS_IN_USE], fDyUp[LEGS_IN_USE], fDzUp[LEGS_IN_USE]
  long fDxDown[LEGS_IN_USE], fDyDown[LEGS_IN_USE], fDzDown[LEGS_IN_USE]
  long fActiveDx[LEGS_IN_USE], fActiveDy[LEGS_IN_USE], fActiveDz[LEGS_IN_USE]
  long previousChangeAmounts[LEGS_IN_USE * CHANGE_ARRAYS * THREE_DIMENSIONS]
  ' ******* Keep Above Together *******
  'long fSpeed
  long radius
  long fFromCenter[LEGS_IN_USE], fFromCenterX[LEGS_IN_USE], fFromCenterY[LEGS_IN_USE]
  long fLegAngle[LEGS_IN_USE]
  long heading, fHeading, ikValue, compassRoseHeading
  long fAngleOffset[LEGS_IN_USE]
  
  
  byte servoPin[SERVOS_IN_USE]
  

  ' each will hold the sevo index used to control it.
  byte waist[LEGS_IN_USE], hip[LEGS_IN_USE], knee[LEGS_IN_USE], adjustCentersFlag
  byte changeIkFlag, stopFlag, pauseFlag, mode, previousMode
  byte zeroCentersFlag

OBJ

  Servo : "Servo32v7"
  Pst : "Parallax Serial Terminal"
  Header : "HexHeader121219a"
   
PUB Setup | localIndex
                                                                                ' 1 cog
  Pst.Start(DEBUG_BAUD)                                                         ' 2 cogs

  Servo.Start

  waitcnt(clkfreq / 20 + cnt)

  centerPtr := Header.ServoCenterAddress

          
  
  repeat localIndex from 0 to LEGS_IN_USE - 1
    waist[localIndex] := localIndex * 3 + WAIST_SERVO
    hip[localIndex] := localIndex * 3 + HIP_SERVO
    knee[localIndex] := localIndex * 3 + KNEE_SERVO
    
    centerPosition[waist[localIndex]] := Header.GetServoCenter(waist[localIndex])
    servoPin[waist[localIndex]] := Header.GetPin(waist[localIndex])
    centerPosition[hip[localIndex]] := Header.GetServoCenter(hip[localIndex])
    servoPin[hip[localIndex]] := Header.GetPin(hip[localIndex])
    centerPosition[knee[localIndex]] := Header.GetServoCenter(knee[localIndex])
    servoPin[knee[localIndex]] := Header.GetPin(knee[localIndex])
    
    directionNew[waist[localIndex]] := Header.GetDirection(waist[localIndex])
    directionNew[hip[localIndex]] := Header.GetDirection(hip[localIndex])
    directionNew[knee[localIndex]] := Header.GetDirection(knee[localIndex])
  

  refreshHz := DEFAULT_REFRESH_HZ
  frameInterval := clkfreq / DEFAULT_REFRESH_HZ

  'cognew(DebugCog, @stack)                                                      ' 5 cogs
  'MainLoop
  CenterServos
  Refresh
  DebugCog
   
{PUB MainLoop 
    
  lastRefresh := cnt
   
  repeat

    if adjustCentersFlag
      CenterServos
      Refresh
    elseif zeroCentersFlag
      repeat
        ZeroServos
        Refresh
      while zeroCentersFlag  
   
}
PUB AdjustCenters | servoId, newPulse
' Called from debug cog.

  adjustCentersFlag := 1
  Pst.str(string(CR, "Enter Servo ID to Adjust (followed by ", QUOTE, "enter", QUOTE, ")"))
  DisplayPulseLengths
  repeat    
    result := Pst.RxCount
    if result
      servoId := Pst.DecIn
      Pst.str(string(CR, "Servo ID entered = "))
      Pst.dec(servoId)
      if servoId < 0 or servoId => SERVOS_IN_USE
        Pst.str(string(CR, "Servo ID out of range."))
      else
        servoPosition[servoId] := centerPosition[servoId] 
        Pst.str(string(CR, "Enter ", QUOTE, "+", QUOTE, " or ", QUOTE, "*", QUOTE)) 
        Pst.str(string(" to increase pulse length for center.")) 
        Pst.str(string(CR, "Enter ", QUOTE, "-", QUOTE, " or ", QUOTE, "/", QUOTE)) 
        Pst.str(string(" to decrease pulse length for center.")) 
        Pst.str(string(CR, "Enter any other key to adjust different servo."))
        Pst.str(string(CR, "Enter ", QUOTE, "x", QUOTE, " to exit AdjustCenters method."))
        result := 1
        repeat while result
          newPulse := Pst.CharIn
          Pst.str(string(CR, "You entered ", QUOTE))
          Pst.char(newPulse)
          Pst.str(string(QUOTE, "."))
          if newPulse == "+"
            Pst.str(string(CR, "Increasing pulse length = "))
            newPulse := servoPosition[servoId] + 1 '<# ABSOLUTE_MAX_PULSE
          elseif newPulse == "*" 
            Pst.str(string(CR, "Increasing pulse length = "))
            newPulse := servoPosition[servoId] + 10 '<# ABSOLUTE_MAX_PULSE
          elseif newPulse == "-" 
            Pst.str(string(CR, "Decreasing pulse length = "))
            newPulse := servoPosition[servoId] - 1 '#> ABSOLUTE_MIN_PULSE
          elseif newPulse == "/" 
            Pst.str(string(CR, "Decreasing pulse length = "))
            newPulse := servoPosition[servoId] - 10 '#> ABSOLUTE_MIN_PULSE
          elseif newPulse == "x" or newPulse == "X"
            newPulse := servoPosition[servoId]
            Pst.str(string(CR, "Exiting AdjustCenters Method"))
            Pst.str(string(CR, "These new center settings will only remain in effect"))
            Pst.str(string(CR, "while the power is one. You will need to change the"))
            Pst.str(string(CR, "center positions in the header in order to make these"))
            Pst.str(string(CR, "changes permanent."))
            
            adjustCentersFlag := 0
            result := 0
          else
            Pst.str(string(CR, "Not a valid instruction."))
            newPulse := servoPosition[servoId]
            result := 0
          'centerPosition[servoId] := ABSOLUTE_MIN_PULSE #> newPulse <# ABSOLUTE_MAX_PULSE
          servoPosition[servoId] := newPulse
          Pst.dec(servoPosition[servoId])
          Refresh
      Pst.str(string(CR, "Enter Servo ID to Adjust (followed by ", QUOTE, "enter", QUOTE, ")"))
      DisplayPulseLengths
  while adjustCentersFlag
  centerPosition[servoId] := servoPosition[servoId]
   
PUB DisplayPulseLengths | localIndex

  Pst.str(string(CR, "{Leg #}[servo#][pin#] = pulseLength"))
  repeat localIndex from 0 to SERVOS_IN_USE - 1
    if localIndex // SERVOS_PER_DISPLAY_LINE == 0
      Pst.char(CR)
    if localIndex // SERVOS_PER_LEG == 0
      Pst.char("{")
      Pst.dec(localIndex / SERVOS_PER_LEG)
      Pst.char("}")   
    Pst.str(string("["))
    Pst.dec(localIndex)
    Pst.str(string("]["))
    Pst.dec(servoPin[localIndex])
    Pst.str(string("] ="))
    Pst.dec(servoPosition[localIndex])
    Pst.char(",")
  Pst.char(CR)
  
PUB DebugCog | localCharacter, localTime

  Pst.str(string(CR, "programName = ", QUOTE))  
  Pst.str(@programName)
  Pst.char(QUOTE)
  Pst.str(string(CR, "Header Name = ", QUOTE))  
  Pst.str(Header.GetProgramName)
  Pst.char(QUOTE)
  DisplayMenu
  localTime := cnt
  repeat    
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
      Pst.str(string(CR, "You entered ", QUOTE))  
      Pst.char(localCharacter)
      Pst.str(string(QUOTE, "."))
      result := 0
      case localCharacter
        "c", "C":
          mode := NORMAL_MODE
          zeroCentersFlag := 1
          AdjustCenters
        "z", "Z":
          'mode := NORMAL_MODE
          'zeroCentersFlag := 1
          ZeroServos
          Refresh  
        other:
          Pst.str(string(CR, "Not a valid command."))
     
      DisplayMenu
        
PRI DisplayMenu

  Pst.str(string(CR, "Press one of following to change robot action."))     
   
  Pst.str(string(CR, "C) Adjust center postitions"))     
  Pst.str(string(CR, "Z) Zero center postitions"))     
                
PUB CenterServos | localIndex

  repeat localIndex from 0 to SERVOS_IN_USE - 1 
    servoPosition[localIndex] := centerPosition[localIndex] 

PUB ZeroServos | localIndex

  repeat localIndex from 0 to SERVOS_IN_USE - 1 
    servoPosition[localIndex] := CENTER 
    centerPosition[localIndex] := CENTER
    
PUB Refresh | localIndex

  {
  repeat localIndex from waist[0] to knee[0]
    servoPosition[localIndex] <#= ABSOLUTE_MAX_PULSE
    servoPosition[localIndex] #>= ABSOLUTE_MIN_PULSE
    Servo.Set(servoPin[localIndex], servoPosition[localIndex])
    Pst.str(string(", sP["))
    Pst.dec(localIndex)
    Pst.str(string("] = "))
    Pst.dec(servoPosition[localIndex])
  }  
  repeat localIndex from 0 to SERVOS_IN_USE - 1
    servoPosition[localIndex] <#= ABSOLUTE_MAX_PULSE
    servoPosition[localIndex] #>= ABSOLUTE_MIN_PULSE
    Servo.Set(servoPin[localIndex], servoPosition[localIndex])

  'DisplayPulseLengths
  
  'repeat while cnt - lastRefresh < frameInterval
  'lastRefresh := cnt
  'lastRefresh += frameInterval
  {repeat localIndex from 0 to SERVOS_IN_USE - 1
    servoPosition[localIndex] <#= ABSOLUTE_MAX_PULSE
    servoPosition[localIndex] #>= ABSOLUTE_MIN_PULSE
    Servo.Set(servoPin[localIndex], servoPosition[localIndex])
  }
  pTime := time
  time := cnt

