DAT programName         byte "HexHeader121219a", 0
CON                                       
  S00 = 1500 '1475
  S01 = 1400
  S02 = 1570
   
  S03 = 1567
  S04 = 1430
  S05 = 1590
   
  S06 = 1500 '1515
  S07 = 1417
  S08 = 1560
   
  S09 = 1500 '1540
  S10 = 1516
  S11 = 1540
   
  S12 = 1530
  S13 = 1440
  S14 = 1540
   
  S15 = 1500 '1544
  S16 = 1440
  S17 = 1470
   
  P00 = 8
  P01 = P00 + 1
  P02 = P00 + 2
  P03 = P00 + 3
  P04 = P00 + 4
  P05 = P00 + 5
  P06 = P00 + 6
  P07 = P00 + 7
  P08 = P00 + 8
  P09 = P00 + 9
  P10 = P00 + 10
  P11 = P00 + 11
  P12 = 25
  P13 = P12 - 1
  P14 = P12 - 2
  P15 = P12 - 3
  P16 = P12 - 4
  P17 = P12 - 5
   
  D00 = -1
  D01 = 1
  D02 = -1
  
  D03 = -1
  D04 = 1
  D05 = -1
  
  D06 = -1
  D07 = -1
  D08 = 1
  
  D09 = -1
  D10 = -1
  D11 = 1
  
  D12 = -1
  D13 = -1
  D14 = 1
  
  D15 = -1
  D16 = 1
  D17 = -1
   
  A00 = (2.0 * PI) / 3.0
  A01 = PI
  A02 = (4.0 * PI) / 3.0
  A03 = PI / 3.0
  A04 = 0.0
  A05 = (5.0 * PI) / 3.0
    
  F_LENGTH_0_1 = 18.0 ' Paul's Hex 
  F_LENGTH_1_2 = 37.8 ' Paul's Hex
  F_LENGTH_2_3 = 56.0 ' Paul's Hex

  F_SQUARED_1_2 = F_LENGTH_1_2 * F_LENGTH_1_2 '1428.84
  F_SQUARED_2_3 = F_LENGTH_2_3 * F_LENGTH_2_3 '3136.0
  F_DOUBLE_1_2 = 2.0 * F_LENGTH_1_2 '75.6
  F_SUM_SQUARED_SEGMENTS = F_SQUARED_1_2 + F_SQUARED_2_3 '4564.84
  F_SQUARE_SUMMED_SEGMENTS = (F_LENGTH_1_2 + F_LENGTH_2_3) * (F_LENGTH_1_2 + F_LENGTH_2_3)
    '8798.44
    
  F_TWO_SEGMENT_PRODUCTS = 2.0 * F_LENGTH_1_2 * F_LENGTH_2_3 '4233.6
  
CON

  F_BOT_WIDTH_MIDDLE = 106.0
  F_BOT_WIDTH = 76.5
  F_BOT_LENGTH = 113.0

  ' Bot Frame
  F_FROM_CENTER_X_0 = -1.0 * (F_BOT_WIDTH / 2.0)
  F_FROM_CENTER_X_1 = -1.0 * (F_BOT_WIDTH_MIDDLE / 2.0)
  F_FROM_CENTER_X_2 = F_FROM_CENTER_X_0
  F_FROM_CENTER_X_3 = F_BOT_WIDTH / 2.0
  F_FROM_CENTER_X_4 = F_BOT_WIDTH_MIDDLE / 2.0
  F_FROM_CENTER_X_5 = F_FROM_CENTER_X_3
  
  F_FROM_CENTER_Y_0 = F_BOT_LENGTH / 2.0
  F_FROM_CENTER_Y_1 = 0.0
  F_FROM_CENTER_Y_2 = -1.0 * F_FROM_CENTER_Y_0
  F_FROM_CENTER_Y_3 = F_FROM_CENTER_Y_0
  F_FROM_CENTER_Y_4 = F_FROM_CENTER_Y_1
  F_FROM_CENTER_Y_5 = F_FROM_CENTER_Y_2

  ' Leg Frame
  F_DEFAULT_X = F_LENGTH_0_1 + F_LENGTH_1_2
  F_DEFAULT_Y = 0.0
  F_DEFAULT_Z = -1.0 * F_LENGTH_2_3 '*  0.25
  
  F_DEFAULT_STRIDE_LENGTH = 40.0 '80.0 ' 32.0 '
  F_DEFAULT_LIFT_X = 0.0 '-10.0 
  F_DEFAULT_LIFT_Y = 0.0 
  F_DEFAULT_LIFT_Z = 31.0
  
  #0, WAIST, HIP, KNEE
  
PUB ServoCenterAddress

  result := @servoCenter

PUB GetServoCenter(localIndex)

  result := servoCenter[localIndex]

PUB GetPin(localIndex)

  result := pinNumber[localIndex]

PUB GetDirection(localIndex)

  result := direction[localIndex]

PUB GetRadiusOffsetX(localIndex)

  result := fFromCenterX[localIndex]
  
PUB GetRadiusOffsetY(localIndex)

  result := fFromCenterY[localIndex]
  
PUB GetAngleOffset(localIndex)

  result := fAngle[localIndex]
  
PUB GetSegmentLength(localIndex)

  result := fJointLength[localIndex]
  
PUB GetProgramName

  result := @programName
    
DAT

servoCenter   long S00, S01, S02
              long S03, S04, S05
              long S06, S07, S08
              long S09, S10, S11
              long S12, S13, S14
              long S15, S16, S17

pinNumber     byte P00, P01, P02
              byte P03, P04, P05
              byte P06, P07, P08
              byte P09, P10, P11
              byte P12, P13, P14
              byte P15, P16, P17

direction     long D00, D01, D02
              long D03, D04, D05
              long D06, D07, D08
              long D09, D10, D11
              long D12, D13, D14
              long D15, D16, D17

fFromCenterX  long F_FROM_CENTER_X_0, F_FROM_CENTER_X_1, F_FROM_CENTER_X_2
              long F_FROM_CENTER_X_3, F_FROM_CENTER_X_4, F_FROM_CENTER_X_5

fFromCenterY  long F_FROM_CENTER_Y_0, F_FROM_CENTER_Y_1, F_FROM_CENTER_Y_2
              long F_FROM_CENTER_Y_3, F_FROM_CENTER_Y_4, F_FROM_CENTER_Y_5

fAngle        long A00, A01, A02
              long A03, A04, A05

fJointLength  long F_LENGTH_0_1, F_LENGTH_1_2, F_LENGTH_2_3
                                                                